//
//	Encoder for G.729A CS-ACELP Speech Codec
// 
//		quantization_of_gains.cpp : Module for 
//			- [A.3.9] Quantization of the gains
//

#include "StdAfx.h"
#include "quantization_of_gains.h"

/*****************************************************************************
/*
/*	  Function to find the fixed codebook gain
/*    Input: c[n] fixed codebook
/*    Output: *gc fixed codebook gain
/*
/****************************************************************************/
void gain_prediction(float c[40], float *gc, float U_h[4])
{
	int n,i;
	float E, E_bar, Em_t, Um;
//	static float U_h[4] = {-14.0, -14.0, -14.0, -14.0};
//	static float prev_gc = (float) 5.5847;
	float b[4]={(float) 0.68, (float) 0.58, (float) 0.34, (float) 0.19};
	float gamma = 0.199526;
	
	*gc = gamma * *gc;

	E_bar = 30;	
	for (n=0, E=0; n<40; n++)
		E += c[n]*c[n];
	E = 10*log10(E/40);

	for (i=0, Em_t=0; i<4; i++)
		Em_t += b[i]*U_h[i];
	
	*gc = pow(10, (Em_t+E_bar+E)/20);
	
	for (i=0; i<3; i++)
		U_h[i] = U_h[i+1];

	U_h[3] = 20*log10(gamma);
}



